<template>
  <VNavigationDrawer
    v-model="drawer"
    clipped
    app
  >
    <VList
      dense
      nav
      class="py-0"
    >
      <VListItem
        two-line
        class="mb-5"
      >
        <VListItemAvatar>
          <img src="https://randomuser.me/api/portraits/men/81.jpg">
        </VListItemAvatar>

        <VListItemContent>
          <VListItemTitle class="primary--text">
            Everson Romero
          </VListItemTitle>
          <VListItemSubtitle>
            <small>eromeso@santodigital.com.br</small>
            <br>
            <span class="text-uppercase">TI - Desenvolvimento</span>
          </VListItemSubtitle>
        </VListItemContent>
      </VListItem>

      <template v-for="(item, i) in items">
        <VListGroup
          v-if="item.children"
          :key="`list-child-${i}`"
          :prepend-icon="`mdi-${item.icon}`"
        >
          <template v-slot:activator>
            <VListItemTitle>{{ item.title }}</VListItemTitle>
          </template>

          <VListItem
            v-for="(child, n) in item.children"
            :key="n"
            class="mx-5"
            :to="child.to"
            link
            nuxt
          >
            <VListItemIcon>
              <VIcon v-text="`mdi-${child.icon}`" />
            </VListItemIcon>

            <VListItemContent>
              <VListItemTitle>{{ child.title }}</VListItemTitle>
            </VListItemContent>
          </VListItem>
        </VListGroup>
        <VListItem
          v-else
          :key="`list-${i}`"
          :to="item.to"
          link
          nuxt
        >
          <VListItemIcon>
            <VIcon v-text="`mdi-${item.icon}`" />
          </VListItemIcon>

          <VListItemContent>
            <VListItemTitle>{{ item.title }}</VListItemTitle>
          </VListItemContent>
        </VListItem>
      </template>
    </VList>

    <template v-slot:append>
      <VList
        dense
        nav
        class="py-0"
      >
        <VListItem link>
          <VListItemIcon>
            <VIcon style="transform: rotateY(-180deg)">
              mdi-export
            </VIcon>
          </VListItemIcon>

          <VListItemContent>
            <VListItemTitle>Sair</VListItemTitle>
          </VListItemContent>
        </VListItem>
      </VList>
    </template>
  </VNavigationDrawer>
</template>

<script lang="ts">
import { Component, Vue } from 'nuxt-property-decorator';

@Component
export default class TheDrawer extends Vue {
  items = [
    { title: 'Início', icon: 'home', to: '/' },
    { title: 'Catálogo de cursos', icon: 'book-multiple-variant', to: '/cursos' },
    { title: 'Perfil', icon: 'emoticon-happy-outline' },
    {
      title: 'Admin',
      icon: 'settings',
      children: [
        { title: 'Usuários', icon: 'account-multiple' },
        { title: 'Catálogo de cursos', icon: 'book-multiple-variant' },
        { title: 'Matrículas', icon: 'account-multiple-plus' },
      ],
    },
    {
      title: 'Estatísticas',
      icon: 'chart-timeline-variant',
      children: [],
    },
  ]

  get drawer() {
    return this.$store.state.drawer;
  }

  set drawer(bool: boolean) {
    this.$store.commit('setDrawer', bool);
  }
}
</script>
